#ifndef _BINTREE
#define _BINTREE

#include "landef.h"
#include "tabs.h"

typedef enum {
	CST,	/* constante */
	VRB,	/* variabile */
	OPR	/* operatore */
}nodekind;

struct treenode{
	nodekind tag;
	union {
		value val;
		typeid stringaid[MAX];
		symbol opcode;
	}U;
	struct treenode *des;
	struct treenode *sin;
};

typedef struct treenode *tree;

/* true se l'albero  vuoto */
extern bool empty(tree);

/* restituisce il nodo sinistro */
extern tree left(tree);

/* restituisce il nodo destro */
extern tree right(tree);

/* construisce un node con figli sin e des */
extern tree constree(tree, tree);

#endif
