#include <stdio.h>
#include "tabs.h"
#include "lex.h"
#include "device.h"
#include "num_conv.h"

/* stampa i simboli */
static void printsy(symbol s) {
	switch(s) {
		case PLUS:	puts("PLUS");			break;
		case MINUS:	puts("MINUS");			break;
		case TIMES:	puts("TIMES");			break;
		case DIVSY:	puts("DIVSY");			break;
		case MODSY:	puts("MODSY");			break;
		case VARSY:	puts("VARSY");			break;
		case IDENT:	printf("IDENT %s\n", id);	break;
		case INTCON:	printf("INTCON %d\n", inum);	break;
		case BECOMES:	puts("BECOMES");		break;
		case COLON:	puts("COLON");			break;
		case SEMICOLON:	puts("SEMICOLON");		break;
		case FULLSTOP:	puts("FULLSTOP");		break;
		case RPAR:	puts("RPAR");			break;
		case LPAR:	puts("LPAR");			break;
		case FINE:	puts("FINE");			break;
		case ERRSY:	puts("ERRSY");			break;
		default:
			puts("**Error (print): simbolo non riconosciuto");
			break;
	}
}

int main () {
	if(initdevice(SOURCE_FILE))
		puts("** Error: apertura file sorgente");
	else {
		setbase(BASE);
		puts("-- Test Lex --");
		initlex();
	
		while(sy != FINE) {
			printsy(sy);
			insymbol();
		}
	}

	return 0;
}
