#include <stdio.h>
#include <ctype.h>
#include "device.h"
#include "landef.h"

#define BUF_LEN 10

static FILE * fp;
static char buffer[BUF_LEN];
static int i;
static void bufferizza();
char ch;

bool initdevice(char *mp_file) {
	fp=fopen(mp_file, "r");

	if(fp == NULL)
		return true;
	else {
		bufferizza();
		return false;
	}
}

void closedevice() {
	fclose(fp);
}

static void bufferizza() {
	char temp;
	i=0;

	while(i<BUF_LEN) {
		fscanf(fp, "%c", &temp);

		if(feof(fp)) {
			temp=TERMINATORE;
			buffer[i]=temp;
			break;
		}

		/* Sostituisco: 0x9 tab, 0xD carriage,
		0xA new line, con 0x20 black */
		if(temp==0x9 || temp==0xD || temp==0xA)
			temp=0x20;

		/* lowercase -> uppercase */
		if(islower(temp))
			temp=toupper(temp);

		/* metto nel buffer */
		buffer[i]=temp;
		i++;
	}
	i=0;
}


void nextch() {

	ch=buffer[i];

	if(i==(BUF_LEN-1))
		bufferizza();
	else
		i++;
}
