#include <string.h>
#include "tabs.h"

#define NUMKEY 3

static char *keyword[NUMKEY]={"DIV", "MOD", "VAR"};
static symbol key[NUMKEY]={DIVSY, MODSY, VARSY};

symbol searchkey(char *ident) {
	symbol s=IDENT;
	int min=0, max=NUMKEY-1, k, i;

	while(min<=max) {
		k=(min+max)/2;

		i=strcmp(ident, keyword[k]);

		if(i==0) {
			s=key[k];
			break;
		}
		else if(i<0)
			max=k-1;
		else if(i>0)
			min=k+1;
	}

	return s;
}

symbol getspecialsy(char ch) {
	symbol s;

	switch(ch) {
		case '+': s=PLUS;	break;
		case '-': s=MINUS;	break;
		case '*': s=TIMES;	break;
		case '/': s=DIVSY;	break;
		case '%': s=MODSY;	break;
		case ';': s=SEMICOLON;	break;
		case '.': s=FULLSTOP;	break;
		case '(': s=LPAR;	break;
		case ')': s=RPAR;	break;
		case '$': s=FINE;	break;
		default: s=ERRSY;	break;
	}

	return s;
}
