#ifndef _TABS
#define _TABS

/* simboli riconosciuti */
typedef enum symbol {
	PLUS,		/* +	*/
	MINUS,		/* -	*/
	TIMES,		/* *	*/
	DIVSY,		/* /	*/
	MODSY,		/* %	*/
	VARSY,		/* var	*/
	IDENT,		/* user	*/
	INTCON,		/* inum	*/
	BECOMES,	/* :=	*/
	COLON,		/* :	*/
	SEMICOLON,	/* ;	*/
	FULLSTOP,	/* .	*/
	LPAR,		/* (	*/
	RPAR,		/* )	*/
	FINE,		/* $	*/
	ERRSY		/* dflt	*/
}symbol;

/* restituisce il symbol corrispondente alla stringa */
extern symbol searchkey(char *ident);

/* restituisce il symbol corrispondente al carattere speciale */
extern symbol getspecialsy(char ch);

#endif
