#ifndef _ASMTRAD
#define _ASMTRAD

#include "landef.h"

/* apre il file di output */
extern void inittrad(char *);

/* chiude il file di output */
extern void closetrad();

/* aggiunge codice assembler per controlli runtime */
extern void enable_debug(bool enable);

/* funzioni dello stack */
extern void varpop(typeid *s);
extern void varpush(typeid *s);
extern void valpush(value i);

/* funzioni per le operazioni matematiche */
extern void addasm();
extern void subasm();
extern void mulasm();
extern void divasm();
extern void modasm();

/* funzioni per aprire e chiudere il file assembly */
extern void prologo();
extern void epilogo();

#endif
