#include "symtab_0.h"
#include <stdio.h>

int main() {
	puts("-- Test Symtab --");

	puts("Inserisco alcuni identificatori");
		tabinsert("GIRAFFA");
		tabinsert("LEONE");
		tabinsert("GAZZELLA");
		tabinsert("ZEBRA");
		tabinsert("PIPPO");
		tabinsert("PLUTO");

	puts("Controllo se alcuni id sono nella symtab");
	if(tabexist("GIRAFFA"))
		printf("\tId nella symtab, dove dovrebbe essere ;)\n");
	else
		printf("\tId non presente, c' qualcosa che tragia :(\n");

	if(tabexist("PAPERINO"))
		printf("\tId nella symtab, ma non dove dovrebbe esserci :(\n");
	else
		printf("\tId non presente, bene, non dovrebbe esserci ;)\n");

	puts("Setto il flag di init ad alcuni identificatori");
		tabsetinit("LEONE");
		tabsetinit("ZEBRA");

	puts("Controllo il flag di init di alcuni identificatori");
	if(tabcheckinit("ZEBRA"))
		printf("\tFlag true, va bene ;)\n");
	else
		printf("\tFlag false, c' qualcosa che tragia :(\n");

	if(tabcheckinit("PIPPO"))
		printf("\tFlag true, ma non dove dovrebbe esserci :(\n");
	else
		printf("\tFlag false, bene, non l'ho mai settato true ;)\n");

	puts("Setto un valore ad alcuni identificatori");
		tabsetvalue("PLUTO", 34);
		tabsetvalue("GIRAFFA", 20);

	puts("Leggo i valori di alcuni identificatori");
		printf("\tValore di un indentificatore: %d\n", tabreadvalue("PLUTO"));
		printf("\tValore di un indentificatore: %d\n", tabreadvalue("GIRAFFA"));

	puts("Stampo tutta la tabella");
		printtab();

	typeid name[MAX];

	puts("Chiamo la tabgetnext 1");
	tabgetinit();
	while(tabgetnext(name))
		printf("\tIdentificatore: %s\n", name);

	puts("Chiamo la tabgetnext 2");
	tabgetinit();
	while(tabgetnext(name))
		printf("\tIdentificatore: %s\n", name);

	return 0;
}
