#include <stdio.h>
#include "lex.h"
#include "tabs.h"
#include "landef.h"
#include "num_conv.h"
#include "device.h"

symbol sy;
value inum;
typeid id[MAX];
char ch;

void initlex() {
	/* chiamo il primo carattere */
	nextch();

	/* rendo disponibile il primo simbolo terminale */
	insymbol();
}

void insymbol() {
	int i;

	/* ignoro gli spazi */
	while(ch==' ')
		nextch();

	/* se  una lettera */
	if((ch>='A') && (ch<='Z')) {
		/* creo la stringa di sole lettere da passare al searchkey */
		id[0]=ch;
		nextch();

		for(i=1; i<MAX && ch>='A' && ch <= 'Z'; i++) {
			id[i]=ch;
			nextch();
		}

		id[i]='\0';

		sy=searchkey(id);
	}
	/* se  una cifra */
	else if((ch>='0') && (ch<='9')) {
		/* creo la stringa di sole 'cifre' da passare al converter */
		id[0]=ch;
		nextch();

		for(i=1; i<MAX && ch>='0' && ch<='9'; i++) {
			id[i]=ch;
			nextch();
		}

		id[i]='\0';

		inum=converter(id);
		sy=INTCON;
	}
	/* se  : */
	else if (ch==':') {
		/* guarda cosa c' dopo */
		nextch();

		/* se  un assegnamento */
		if(ch=='=') {
			sy=BECOMES;
			nextch();
		}

		/* se  una dichiarazione */
		else
			sy=COLON;
	}
	/* ...allora sar un carattere speciale */
	else {
		sy=getspecialsy(ch);
		nextch();
	}
}
