#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "num_conv.h"

static char base_num;

void setbase(int base) {
	if(base>1 && base<17)
		base_num=base;
	else {
		puts("** Error: le basi devono essere comprese tra 2 e 16");
		exit(1);
	}
}

unsigned int converter(char *st) {
	unsigned int dec, esponente=1, converted=0;
	int i;

	/* scorro la stringa dalla cifra meno significativa */
	for(i=strlen(st)-1; i>=0; i--) {
		dec=st[i];

		if(dec>='A' && dec<='F')
			dec=dec-55;
		else
			dec=dec-48;


		if(dec<0 || dec>=base_num) {
			puts("** Error: simboli non validi in questa base");
			exit(1);
		}

		if(dec>0)
			converted=converted+(dec*esponente);

		esponente=esponente*base_num;
	}
	return converted;
}
